#!/bin/bash
#
# Script: backups.sh
# Author: dacomo
# Date: 05-05-23
# Version: 1.0
#
# 2- Develope a script called backup.sh that:
# a) Firstly, it checks if the script is being run by the root user. If it is not  being run by the root user, it will be terminated returning an exit code equal to 1 and showing: "This script must be run as root".
# b) Afterwards, check if a directory called /backups exists on your system. If the directory does not exist, it will be created. If the directory can not be created, your script will be terminated returning an exit
# code equal to 2 and showing: "/backups can not be created".
# c) Ask the user for a directory name inside /backups. If the directory does not exist, it will be created by your script. If the directory can not be created, your script will be terminated returning an exit code
# equal to 3 and showing: "Error creating directories in /backups".
# d) Ask the user an extension
# e) Ask the user a directory name  where files with the extension given by the user could be found.
# f) For each file in the second directory with the extension provided by the user:
#    - Your script check if its size is not zero
#    - If the file size is not zero then, the file will be copied in the directory created in step c).
#    - Finally, the script packs and compress  the directory created in step c)  adding to file name the current  date and time.
# Your script will terminate returning an exit code exit code equal to 0 if everything works
#
clear
if (( EUID != 0 ))
then
  echo "This script must be run as a root"
  exit 1 
fi
if [[ ! -d /backups ]]
then
	mkdir /backups 2> /dev/null # 2> /dev/null redirects error output messageto /dev/null. Only the script error messages will be displayed
	if [[ $? != 0 ]]
	then
		echo "/backups can not be created"
		exit 2
	fi
fi
echo -n "Enter a directory name to be created inside /backups: "
read newbackupdir
if [[ ! -d /backups/$newbackupdir ]]
then
	mkdir /backups/$newbackupdir 2> /dev/null 
	if [[ $? != 0 ]]
	then
		echo "Error creating directories inside /backups"
		exit 3
	fi
fi
echo -n "Enter an file extension: "
read extension
echo -n "Enter an directory  where files with the extension given by the user could be found: "
read sourcedir
for filename in $sourcedir/*.$extension
do
	if [[ -s $filename ]] # -s returns true if file is not zero size
	then
		cp $filename /backups/$newbackupdir 2> /dev/null 
	fi
done
DATE=$(date +%Y%m%d%H%M%S)
cd /backups
tar cfz $newbackupdir$DATE.tar.gz $newbackupdir 2> /dev/null 
rm -r $newbackupdir 2> /dev/null #$newbackupdir is no longer required because has been compressed
exit 0
