#!/bin/bash
#
# Script: menu_installer.sh
# Author: dacomo
# Date: 05-05-23
# Version: 1.0
#
# 6- Write a script called menu_installer.sh that:
# a) Firstly, it checks if the script is being run by the root user. If it is not  being run by the root user, it will be terminated returning an exit code equal to 5 and showing: "This script must be run as root".
# b) Secondly, it shows a menu with the following options:
#      1) Run a command to update the list of software packages available
#      2) Run a command to install a package called  ipcalc
#      3) Run a command to to install a package called  jed
#      4) Run a command to remove ipcalc
#     5) Run a command to remove and purge jed
# If you select any other option, the following message will be displayed: "Wrong option. Please, select 1/2/3/4/5"   
# c) Thirdly, the selected option is run.
# d) Finally, it shows a message asking the user if he/she wants to continue (option y) or not (option n). If the user select y, the terminal will be cleared and the menu will be shown again.
# e) Your script must terminate returning an exit code equal to 0 if everything works fine. 
#
clear
if (( EUID != 0 ))
then
  echo "This script must be run as a root"
  exit 5 
fi
cont="y"
while [[ $cont == "y" ]]
do
	clear
	echo "MENU:"
	echo "1) Update the list of software"
	echo "2) Install ipcalc"
	echo "3) Install jed"
	echo "4) Remove ipcalc"
	echo "5) Remove and purge jed"
	echo -n "Select an option: "
	read op
	case $op in
		1) 	aptitude -y update
			;;
		2) 	aptitude install -y ipcalc
			;;
		3) 	aptitude install -y jed
			;;
		4) 	aptitude remove -y ipcalc
			;;
		5) 	aptitude remove -y jed
			aptitude purge -y jed
			;;	
		*) 	echo "Wrong option. Please, select 1/2/3/4/5"
			;;
	esac
	echo -n "Do you want to continue [y/n] (n -default option): "
	read cont 
done
exit 0
