#!/bin/bash
#
# Script: usrgrps.sh
# Author: dacomo
# Date: 04-05-23
# Version: 1.0
#
# 1- Develope a script called usrgrps.sh that:
# a) Firstly, it checks if the script is being run by the root user. If it is not  being run by the root user, it will be terminated returning an exit code equal to 1 and showing: "This script must be run as root".
# b) Secondly, it shows a menu with the following options:
#     1) Create a new group -> Your script will ask for: a group name and a GID number.
#     2) Create a new user -> Your script will ask for: a username, a UID number and a home directory name. Default group: users.  Shell: /bin/bash. Skeleton /etc/skel. Additional group: vboxsf. Password: FjeClot23$
#     3) Remove a group -> Your script will ask for: a group name.
#     4) Remove a user -> Your script will ask for: a username
# If you select any other option, the following message will be displayed: "Wrong option. Please, select 1/2/3/4/"
# c) Your script will terminate returning an exit code exit code equal to 0 if everything works fine but
#    - if your script fails to create the new group, it will terminate returning an exit code equal to 2. and the following message will be displayed: "The new group can not be created"
#    - if your script fails to create the new user, it will terminate returning an exit code equal to 3. "The new user can not be created"
#    - if your script fails to remove the group, it will terminate returning an exit code equal to 4. "The new group can not be removed"
#    - if your script fails to remove the user, it will terminate returning an exit code equal to 5. "The new user can not be removed" 
#
clear
if (( EUID != 0 ))
then
  echo "This script must be run as a root"
  exit 1 
fi
clear
echo "MENU:"
echo "1) Create a new group"
echo "2) Create a new user"
echo "3) Remove a group"
echo "4) Remove an user"
echo -n "Select an option: "
read op
case $op in
	1) 	clear
		echo -n "Group name: "
		read group
		echo -n "GID: "
		read gid
		groupadd $group -g $gid 2> /dev/null # 2> /dev/null redirects error output messageto /dev/null. Only the script error messages will be displayed
		if [[ $? != 0 ]]
		then
			echo "The new group can not be created"
			exit 2
		fi
		;;
	2) 	clear
		echo -n "User name: "
		read username
		echo -n "UID: "
		read uid
		echo -n "Personal folder: "
		read homedir
		useradd $username -u $uid -g users -d $homedir -m -k /etc/skel -s /bin/bash -G vboxsf -p $(mkpasswd FjeClot23$) 2> /dev/null
		if [[ $? != 0 ]]
		then
			echo "The new user can not be created" 
			exit 3
		fi
		;;
	3) 	clear
		echo -n "Group name: "
		read group
		groupdel $group 2> /dev/null
		if [[ $? != 0 ]]
		then
			echo "The new group can not be removed"
			exit 4
		fi
		;;
	4) 	clear
		echo -n "Username: "
		read username
		userdel -r $username 2> /dev/null
		if [[ $? != 0 ]]
		then
			echo "The new user can not be removed"
			exit 5
		fi
		;;
	*) 	echo "Wrong option. Please, select 1/2/3/4"
		;;
esac
exit 0
